VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "mscomm32.ocx"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Ficara 2006 Stepper Test"
   ClientHeight    =   3225
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   2745
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3225
   ScaleWidth      =   2745
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox Check1 
      Caption         =   "Driver enable"
      Height          =   375
      Left            =   120
      TabIndex        =   9
      Top             =   1200
      Width           =   855
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "S&top"
      Height          =   495
      Left            =   1800
      TabIndex        =   8
      Top             =   1680
      Width           =   615
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      ItemData        =   "Form1.frx":030A
      Left            =   1440
      List            =   "Form1.frx":032F
      Style           =   2  'Dropdown List
      TabIndex        =   7
      ToolTipText     =   "Max speed when running"
      Top             =   90
      Width           =   975
   End
   Begin VB.TextBox txtMessage 
      Height          =   375
      Left            =   120
      Locked          =   -1  'True
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   2280
      Width           =   2535
   End
   Begin VB.CommandButton cmdInternet 
      Caption         =   "Go to my website"
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   2760
      Width           =   2535
   End
   Begin VB.CommandButton cmdStartCCW 
      Caption         =   "St&art CCW"
      Height          =   495
      Left            =   1080
      TabIndex        =   4
      Top             =   1080
      Width           =   615
   End
   Begin VB.CommandButton cmdStartCW 
      Caption         =   "&Start CW"
      Height          =   495
      Left            =   1800
      TabIndex        =   3
      Top             =   1080
      Width           =   615
   End
   Begin VB.TextBox txtSteps 
      Height          =   285
      Left            =   1440
      MaxLength       =   5
      TabIndex        =   0
      Text            =   "200"
      ToolTipText     =   "Range 1 to 30000"
      Top             =   585
      Width           =   615
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   2040
      Top             =   442
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      InBufferSize    =   256
      OutBufferSize   =   256
      BaudRate        =   1200
   End
   Begin VB.Label Label3 
      Caption         =   "MOT.."
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   10
      Top             =   1800
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Speed(steps/Sec)"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "Num. of  Steps"
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   600
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'--------------------------------------------------------------------------
' This program uses the serial port to drive a stepper motor controller
'  like L297-L298 or similar, using the DIR, CLK end ENA signals.
' The electric diagram for interfacing the serial port to the controller
'  can be downloaded from my website http://sites.google.com/site/eficara
'  in the section CNC/G-code under Windows freeware.
' If you found something interesting on my website, please put a reference
'  to it in your projects, thanks !
' --------------------------------- Emilio Pietro Giovanni Ficara
Option Explicit
Dim clk As String
Private Declare Function ShellExecute Lib _
     "shell32.dll" Alias "ShellExecuteA" _
     (ByVal hWnd As Long, ByVal lpOperation _
     As String, ByVal lpFile As String, ByVal _
     lpParameters As String, ByVal lpDirectory _
     As String, ByVal nShowCmd As Long) As Long

Private Sub Check1_Click()
  If Check1.Value = Checked Then
    MSComm1.RTSEnable = True
  Else
    MSComm1.RTSEnable = False
  End If
End Sub

Private Sub cmdInternet_Click()
  On Error Resume Next
  ShellExecute 0&, vbNullString, "http://sites.google.com/site/eficara", vbNullString, _
      vbNullString, 1 'SHOWNORMAL
End Sub

Private Sub MoveStepper() ' this SUB creates a string with right number of clocks
Dim i As Integer
Dim j As Integer
  i = Val(txtSteps.Text) ' get programmed number of steps
  If i = 0 Or i > 30000 Then
    txtMessage = "Num of steps: out of range"
  Else
    txtMessage = "Steps: " & i & " Speed: " & Combo1.Text
    j = Int(i / 5)
    i = i - (j * 5)
    clk = String$(j, &H55) ' 0x55 means 5 clocks, the start bit plus 4 zeroes
    If i > 0 Then
      Select Case i
        Case 1
          j = &HFF ' single clock, the start bit
        Case 2
          j = &HFD ' two clocks, the start bit plus bit1
        Case 3
          j = &HF5 ' three clocks, the start bit plus bit1 and bit3
        Case 4
          j = &HD5 ' four clocks, the start bit plus bit1, bit3 and bit5
      End Select
      clk = clk & Chr$(j)
    End If
'    MSComm1.Output = clk ' output the full string (the num of zeroes is the num of clocks)
    For i = 1 To Len(clk) ' output the full string, or say the programmed num of clocks
      DoEvents
      MSComm1.Output = Mid$(clk, i, 1)
    Next i
  End If
End Sub

Private Sub cmdStartCW_Click()
  MSComm1.DTREnable = True
  MoveStepper
End Sub

Private Sub cmdStartCCW_Click()
  MSComm1.DTREnable = False
  MoveStepper
End Sub

Private Sub cmdStop_Click()
  clk = ""
  MSComm1.OutBufferCount = 0 ' flush the output queue
End Sub

Private Sub Combo1_Click()
  MSComm1.Settings = CStr(2 * Int(Combo1.Text)) & ",n,8,1"
End Sub

Private Sub Form_Load()
Dim parms As String
Dim fnam As String
Dim accept As Integer

  fnam = "stparms.ini" ' load parameters (port, motor index) from file
  If Dir(fnam) = "" Then ' if file does not exist
    parms = "This program is supplied AS IS, without any implicit or explicit warranty." & Chr(13)
    parms = parms & "I'm not responsible for damages coming from the use of this program." & Chr(13)
    parms = parms & "Do you accept this agreement ?"
    accept = MsgBox(parms, vbInformation Or vbDefaultButton2 Or vbYesNo, "DISCLAIMER:")
    If accept <> vbYes Then End
    Open fnam For Output As #1 ' create stparms.ini if not exists
    Print #1, "com=01" ' use 2 digits for the port number
    Print #1, "mot=X" ' simbolic reference for motor (typ. X,Y,Z)
    Close #1
  End If
  
  Combo1.ListIndex = 2
  Open fnam For Input As #2
  Line Input #2, parms
  MSComm1.CommPort = Val(Right$(parms, 2))
  Line Input #2, parms
  Label3.Caption = "MOT." & Right$(parms, 1)
  Close #2
  On Error Resume Next
  MSComm1.PortOpen = True
  If Err Then
    MsgBox "COM" & MSComm1.CommPort & " not available.", vbCritical, "COMM Port Error"
    End
  End If
  txtMessage.Text = "Load parms: COM" & MSComm1.CommPort & ", " & Label3.Caption
End Sub

Private Sub Form_Unload(Cancel As Integer)
  If MSComm1.PortOpen = True Then
    MSComm1.RTSEnable = False
    MSComm1.PortOpen = False
  End If
End Sub
